import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.opengl.*; 
import org.openkinect.*; 
import org.openkinect.processing.*; 
import hypermedia.video.*; 
import java.awt.*; 
import processing.serial.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class BestaireRadioInterActifLinux extends PApplet {


// x pour afficher les valeurs + boid
// a pour augmenter le seuil
// q pour baisser le seuil
// p pour d\u00e9caler les boids vers le haut
// m pour d\u00e9caler les boids vers le bas








OpenCV opencv;
Kinect kinect;
Flock flock;
Serial portSerie;

boolean showvalues = false;
boolean scrollbar = false;
boolean radio;

// Kinect
int largeurKinect = 640;
int hauteurKinect = 480;
int seuil = 690; // Distance en millim\u00e8tre de la Kinect 4500 \u00e0 bourges
int Yvect = 100;
PImage calcul;
float deg = 15; // Start at 15 degrees
int tailleMaxRecherche;
int nombreMaxBlobs;
int tampon; // Tampon des blobs
int[][] moyenne;
int temoin;
Blob[] blobs;
// int compteur;
PVector correctionKinect;
// PVector correctionCentreBlobs;

public void setup() {
  size(1024, 768, OPENGL);
  frameRate(60);
  smooth(4); // R\u00e9glage de l'anti aliasing 0, 2, 4 ou 8

  // Kinect
  kinect = new Kinect(this);
  kinect.start();
  kinect.enableDepth(true);
  calcul = createImage(largeurKinect, hauteurKinect, RGB);
  calcul.loadPixels();
  correctionKinect = new PVector(0, Yvect); // Vecteur de correction pour compenser le d\u00e9calage entre la kinect et le vid\u00e9oprojecteur (ajout syst\u00e9matique de valeurs en x et y aux blobs calcul\u00e9s)

  // Blob
  opencv = new OpenCV(this);
  opencv.allocate(largeurKinect, hauteurKinect);
  tailleMaxRecherche = largeurKinect * hauteurKinect / 3;
  nombreMaxBlobs = 10; // Nbre max de blobs (personnes) d\u00e9tect\u00e9es simultan\u00e9ment
  tampon = 10;
  moyenne = new int[nombreMaxBlobs][tampon];

  //Aquarium
  setupScrollbars();
  colorMode(RGB, 255, 255, 255, 100);
  flock = new Flock();
  // Initialisation des boids
  for (int i = 0; i < 20; i++) {
    flock.addBoid(new Boid(width/2, height/2, "Lombric"));
  }
  for (int i = 0; i < 20; i++) {
    flock.addBoid(new Boid(width/2, height/2, "Mouche"));
  }

  // Arduino
  for (int i = 0; i < Serial.list().length; i++) {
    println(Serial.list()[i]);
  }
  String nomPort = Serial.list()[0];
  portSerie = new Serial(this, nomPort, 115200);

  // Mode radioActif off
  radio = false;

  // Pr\u00e9paration pour plein ecran 
  //frame.removeNotify();
  //frame.setUndecorated(true);
  //frame.addNotify();
}

public void draw() {
  //  if(frameCount == 1) {
  //      //frame.setLocation(1363, -28);
  //      //frame.setLocation(, 0);
  //}


  // Arduino
  if (portSerie.available() > 0) { 
    portSerie.read();
    radio = true;
    temoin = frameCount;
  }

  // Raffraichissement \u00e9cran
  if ((radio) && ((frameCount - temoin) < 5)) {
    background(0);
  } 
  else {
    background(255, 255, 255);
    radio = false;
  }

  // Kinect
  int[] profondeur = kinect.getRawDepth();
  for (int i = 0; i < profondeur.length; i++) {
    // for (int i = 0; i < largeurKinect * hauteurKinect; i++) {
    calcul.pixels[i] =  (profondeur[i] < seuil) ? 0xFFFFFF : 0x000000;
  }
  calcul.updatePixels();
  image( calcul, 0, 0, width, height);

  // Blobs
  opencv.copy(calcul);
  blobs = opencv.blobs(tailleMaxRecherche/200, tailleMaxRecherche, 10, false );
  for ( int i=0; i < blobs.length; i++ ) {
    float diametre = blobs[i].length;
    blobs[i].centroid.x = blobs[i].centroid.x * width / largeurKinect + (int)correctionKinect.x;
    blobs[i].centroid.y = blobs[i].centroid.y * height / hauteurKinect + (int)correctionKinect.y;
    if (showvalues) {
      noFill();
      strokeWeight(3);
      stroke(255, 0, 0);
      ellipse(blobs[i].centroid.x, blobs[i].centroid.y, diametre/3, diametre/3);
    }
  }

  if (blobs != null) {
    flock.run(blobs);
  }

  // Aquarium
  drawScrollbars();

  if (mousePressed && !scrollbar) {
    switch (round(random(0, 2))) {
    case 0 :
      flock.addBoid(new Boid(mouseX, mouseY, "Lombric"));
      break;
    case 1 :
      flock.addBoid(new Boid(mouseX, mouseY, "Mouche"));
      break;
    }
  }

  if (showvalues) {
    fill(255, 0, 0);
    textAlign(LEFT);
    text("Total boids: " + flock.boids.size() + "\n" + "Framerate: " + round(frameRate) + "\nPress any key to show/hide sliders and text\nClick mouse to add more boids" + "\nSeuil: " + seuil + "\nVecteur-Y: " + Yvect, 5, 100);
  }
}

public void keyPressed() {
  if(key == 'x') showvalues = !showvalues;
  else if(key == 'a') seuil++;
  else if(key == 'q') seuil--;
  else if(key == 'p') Yvect--;
  else if(key == 'm') Yvect++;
  correctionKinect = new PVector(0, Yvect);
  

}

public void mousePressed() {
}

public void stop() {
  kinect.quit();
  opencv.stop();
  super.stop();
}

float swt = 25.0f;     //sep.mult(25.0f);
float awt = 4.0f;      //ali.mult(4.0f);
float cwt = 5.0f;      //coh.mult(5.0f);
float maxspeed = 1;
float maxforce = 0.025f;


// Flocking
// Daniel Shiffman <http://www.shiffman.net>
// The Nature of Code, Spring 2009

// Boid class
// Methods for Separation, Cohesion, Alignment added

class Boid {

  PVector loc;
  PVector vel;
  PVector acc;
  PVector[] segment; 
  float tailleSegment = 20;
  int nombreSegment;
  float r;
  int typeMonstre; // 0 : Lombric, 1 : Mouche

  Boid(float x, float y, String _typeMonstre) {
    acc = new PVector(0, 0);
    vel = new PVector(random(-1, 1), random(-1, 1));
    loc = new PVector(x, y);
    if (_typeMonstre.equals("Lombric")) {
      typeMonstre = 0;
      nombreSegment = 5;
    }
    if (_typeMonstre.equals("Mouche")) {
      typeMonstre = 1;
      nombreSegment = 2;
    }
    r = 10.0f;
    segment = new PVector[nombreSegment];
    for (int i = 0; i < segment.length; i++) {
      segment[i] = new PVector(0, 0);
    }
  }

  public void run(ArrayList<Boid> boids, Blob[] blobs) {
    flock(boids, blobs);
    update();
    //borders();
    render();
  }

  public void applyForce(PVector force) {
    // We could add mass here if we want A = F / M
    acc.add(force);
  }

  // We accumulate a new acceleration each time based on three rules
  public void flock(ArrayList<Boid> boids, Blob[] blobs) {
    PVector sep = separate(boids);   // Separation
    PVector ali = align(boids);      // Alignment
    PVector coh = cohesion(boids);   // Cohesion
    PVector bor = bordure();
    PVector attraction = fuite(blobs);
    // Arbitrarily weight these forces
    sep.mult(swt);
    ali.mult(awt);
    coh.mult(cwt);
    //bor.mult(1.0);
    attraction.mult(-20);
    // Add the force vectors to acceleration
    applyForce(sep);
    applyForce(attraction);
    applyForce(bor);
    if (typeMonstre == 0) {
      applyForce(ali);
      applyForce(coh);
    }
  }

  // Method to update location
  public void update() {
    // Update velocity
    vel.add(acc);
    // Limit speed
    vel.limit(maxspeed);
    loc.add(vel);
    // Reset accelertion to 0 each cycle
    acc.mult(0);
  }

  // A method that calculates and applies a steering force towards a target
  // STEER = DESIRED MINUS VELOCITY
  public PVector seek(PVector target) {
    PVector desired = PVector.sub(target, loc);  // A vector pointing from the location to the target

    // Normalize desired and scale to maximum speed
    desired.normalize();
    desired.mult(maxspeed);
    // Steering = Desired minus Velocity
    PVector steer = PVector.sub(desired, vel);
    steer.limit(maxforce);  // Limit to maximum steering force
    return steer;
  }

  public void render() {
    // Draw a triangle rotated in the direction of velocity
    float theta = vel.heading2D() + radians(90);
    //strokeWeight(5);
    noStroke();
    fill(0);
    dragSegment(0, loc);
    for (int i=0; i<segment.length-1; i++) {
      dragSegment(i+1, segment[i]);
    }
  }

  public void dragSegment(int i, PVector segmentInt) {
    PVector delta = PVector.sub(segmentInt, segment[i]);
    float angle = atan2(delta.y, delta.x);  
    segment[i].x = segmentInt.x - cos(angle) * tailleSegment;
    segment[i].y = segmentInt.y - sin(angle) * tailleSegment;
    switch (typeMonstre) {
    case 0 :
      segmentLombric(segment[i], angle, i);
      break;
    case 1 : 
      segmentMouche(segment[i], angle, i);
      break;
    }
  }

  public void segmentLombric(PVector seg, float a, int numero) {
    pushMatrix();
    translate(seg.x, seg.y);
    rotate(a);
    if (radio) {
      noFill();
      stroke(100, 255, 0);
    } 
    else {
      fill(0);
      noStroke();
    }
    ellipse(tailleSegment/2, 0, tailleSegment, tailleSegment/(numero + 1));
    if (numero == 0) {
      if (radio) {
        noFill();
      } 
      else {
        fill(255);
      }
      ellipse(3*tailleSegment/5, 0, tailleSegment/2, tailleSegment/2);
      if (radio) {
        noFill();
      } 
      else {
        fill(0);
      }
      ellipse(3*tailleSegment/4, 0, tailleSegment/5, tailleSegment/5);
    }
    popMatrix();
  }

  public void segmentMouche(PVector seg, float a, int numero) {
    pushMatrix();
    translate(seg.x, seg.y);
    rotate(a);
    switch(numero) {
    case 0 : 
      if (radio) {
        noFill();
        stroke(100, 255, 0);
      } 
      else {
        fill(0);
        noStroke();
      }
      //Segment 1
      //T\u00eate
      ellipse(tailleSegment/3, 0, 2*tailleSegment/3 + 1, tailleSegment/ 1.2f);
      //Yeux
      ellipse(tailleSegment/3, - tailleSegment/ 2.9f, tailleSegment / 2, tailleSegment / 2);
      ellipse(tailleSegment/3, tailleSegment/ 2.9f, tailleSegment / 2, tailleSegment / 2);

      if (radio) {
        noFill();
        stroke(100, 255, 0);
        strokeWeight(1);
      } 
      else {
        stroke(0);
        strokeWeight(tailleSegment/10);
      }      
      line(tailleSegment, 0, tailleSegment/2, 0);

      if (radio) {
        noFill();
        stroke(100, 255, 0);
      } 
      else {
        noStroke();
        fill(255);
      }
      ellipse(tailleSegment/3, - tailleSegment/ 2.9f, tailleSegment / 3, tailleSegment / 3);
      ellipse(tailleSegment/3, tailleSegment/ 2.9f, tailleSegment / 3, tailleSegment / 3);
      if (radio) {
        noFill();
        stroke(100, 255, 0);
      } 
      else {
        fill(0);
        noStroke();
      }
      ellipse(tailleSegment/3, - tailleSegment/ 2.9f, tailleSegment / 6, tailleSegment / 3);
      ellipse(tailleSegment/3, tailleSegment/ 2.9f, tailleSegment / 6, tailleSegment / 3);
      break;
    case 1 :
      if (radio) {
        noFill();
        stroke(100, 255, 0);
        strokeWeight(tailleSegment / 20);
      } 
      else {
        fill(255);
        stroke(0);
        strokeWeight(tailleSegment / 20);
      }
      bezier(0, 0, tailleSegment/8, 1.2f*tailleSegment, 2*tailleSegment, tailleSegment, tailleSegment/2, 0); 
      bezier(0, 0, tailleSegment/8, -1.2f*tailleSegment, 2*tailleSegment, -tailleSegment, tailleSegment/2, 0); 
      if (radio) {
        noFill();
        stroke(100, 255, 0);
      } 
      else {
        fill(0);
        noStroke();
      }
      ellipse(tailleSegment /2, 0, 1.2f * tailleSegment, tailleSegment/1.8f);
      break;
    }
    popMatrix();
  }

  public PVector bordure() {
    float coefficient = 1.15f;
    PVector effetBordure = new PVector(0, 0, 0);
    if (loc.x < 80) {
      effetBordure.add(new PVector(pow(coefficient, 10 - loc.x), 0));
    }
    if (loc.x > width - 40) {
      effetBordure.add(new PVector(-pow(coefficient, 10 - (width - loc.x)), 0));
    }
    if (loc.y < 40) {
      effetBordure.add(new PVector(0, pow(coefficient, 10 - loc.y)));
    }
    if (loc.y > height - 40) {
      effetBordure.add(new PVector(0, -pow(coefficient, 10 - (height - loc.y))));
    }
    //effetBordure.div(10);
    return effetBordure;
  }

  // Wraparound
  public void borders() {
    if (loc.x < 0) vel.x = -vel.x;
    if (loc.y < 0) vel.y = -vel.y;
    if (loc.x > width) vel.x = -vel.x;
    if (loc.y > height) vel.y = -vel.y;
  }

  // Separation
  // Method checks for nearby boids and steers away
  public PVector separate (ArrayList<Boid> boids) {
    float desiredseparation = 25.0f;
    PVector steer = new PVector(0, 0);
    int count = 0;
    // For every boid in the system, check if it's too close
    for (Boid other : boids) {
      float d = PVector.dist(loc, other.loc);
      // If the distance is greater than 0 and less than an arbitrary amount (0 when you are yourself)
      if ((d > 0) && (d < desiredseparation)) {
        // Calculate vector pointing away from neighbor
        PVector diff = PVector.sub(loc, other.loc);
        diff.normalize();
        diff.div(d);        // Weight by distance
        steer.add(diff);
        count++;            // Keep track of how many
      }
    }
    // Average -- divide by how many
    if (count > 0) {
      steer.div((float)count);
      // Implement Reynolds: Steering = Desired - Velocity
      steer.normalize();
      steer.mult(maxspeed);
      steer.sub(vel);
      steer.limit(maxforce);
    }
    return steer;
  }

  // Alignment
  // For every nearby boid in the system, calculate the average velocity
  public PVector align (ArrayList<Boid> boids) {
    float neighbordist = 50.0f;
    PVector steer = new PVector();
    int count = 0;
    for (Boid other : boids) {
      float d = PVector.dist(loc, other.loc);
      if ((d > 0) && (d < neighbordist)) {
        steer.add(other.vel);
        count++;
      }
    }
    if (count > 0) {
      steer.div((float)count);
      // Implement Reynolds: Steering = Desired - Velocity
      steer.normalize();
      steer.mult(maxspeed);
      steer.sub(vel);
      steer.limit(maxforce);
    }
    return steer;
  }

  // Cohesion
  // For the average location (i.e. center) of all nearby boids, calculate steering vector towards that location
  public PVector cohesion (ArrayList<Boid> boids) {
    float neighbordist = 50.0f;
    PVector sum = new PVector(0, 0);   // Start with empty vector to accumulate all locations
    int count = 0;
    for (Boid other : boids) {
      float d = PVector.dist(loc, other.loc);
      if ((d > 0) && (d < neighbordist)) {
        sum.add(other.loc); // Add location
        count++;
      }
    }
    if (count > 0) {
      sum.div((float)count);
      return seek(sum);  // Steer towards the location
    }
    return sum;
  }
  
  public PVector fuite(Blob[] blobs) {
    PVector somme = new PVector(0, 0, 0);
    int compteur = 0;
    for (int i = 0; i < blobs.length; i++ ) {
      float diametre = blobs[i].length;
      PVector centreBlob = new PVector(blobs[i].centroid.x, blobs[i].centroid.y);
      float d = PVector.dist(loc, centreBlob);
      if ((d > 0) && (d < diametre/3)) {
        somme.add(centreBlob);
        compteur++;
      }
    }
    if (compteur > 0) {
      somme.div((float)compteur);
      return seek(somme);
    }
    return somme;
  }
}

// Flocking
// Daniel Shiffman <http://www.shiffman.net>
// The Nature of Code, Spring 2011

// Flock class
// Does very little, simply manages the ArrayList of all the boids

class Flock {
  ArrayList<Boid> boids; // An ArrayList for all the boids

  Flock() {
    boids = new ArrayList<Boid>(); // Initialize the ArrayList
  }

  public void run(Blob[] blobs) {
    for (Boid b : boids) {
      b.run(boids, blobs);  // Passing the entire list of boids to each boid individually
    }
  }

  public void addBoid(Boid b) {
    boids.add(b);
  }

}



// Code based on "Scrollbar" by Casey Reas

HScrollbar[] hs = new HScrollbar[5];//
String[] labels =  {"separation", "alignment","cohesion","maxspeed","maxforce"};

int x = 5;
int y = 20;
int w = 50;
int h = 8;
int l = 2;
int spacing = 4;

public void setupScrollbars() {
  for (int i = 0; i < hs.length; i++) {
    hs[i] = new HScrollbar(x, y + i*(h+spacing), w, h, l);
  }

  hs[0].setPos(0.5f);
  hs[1].setPos(0.5f);
  hs[2].setPos(1.0f);
  hs[3].setPos(0.9f);
  hs[4].setPos(0.05f);

}

public void drawScrollbars() {
  //if (showvalues) {
  swt = hs[0].getPos()*10.0f;     //sep.mult(25.0f);
  awt = hs[1].getPos()*2.0f;     //sep.mult(25.0f);
  cwt = hs[2].getPos()*2.0f;     //sep.mult(25.0f);
  maxspeed = hs[3].getPos()*10.0f;
  maxforce = hs[4].getPos()*0.5f;


  if (showvalues) {
    for (int i = 0; i < hs.length; i++) {
      hs[i].update();
      hs[i].draw();
      fill(255, 0, 0);
      textAlign(LEFT);
      text(labels[i],x+w+spacing,y+i*(h+spacing)+spacing);
      //text(hs[i].getPos(),x+w+spacing+75,y+i*(h+spacing)+spacing);
    }
  }
}


class HScrollbar
{
  int swidth, sheight;    // width and height of bar
  int xpos, ypos;         // x and y position of bar
  float spos, newspos;    // x position of slider
  int sposMin, sposMax;   // max and min values of slider
  int loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;

  HScrollbar (int xp, int yp, int sw, int sh, int l) {
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    spos = xpos;
    newspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    loose = l;
  }

  public void update() {
    if(over()) {
      over = true;
    } 
    else {
      over = false;
    }
    if(mousePressed && over) {
      scrollbar = true;
      locked = true;
    }
    if(!mousePressed) {
      locked = false;
      scrollbar = false;
    }
    if(locked) {
      newspos = constrain(mouseX-sheight/2, sposMin, sposMax);
    }
    if(abs(newspos - spos) > 0) {
      spos = spos + (newspos-spos)/loose;
    }
  }

  public int constrain(int val, int minv, int maxv) {
    return min(max(val, minv), maxv);
  }

  public boolean over() {
    if(mouseX > xpos && mouseX < xpos+swidth &&
      mouseY > ypos && mouseY < ypos+sheight) {
      return true;
    } 
    else {
      return false;
    }
  }

  public void draw() {
    fill(255);
    rectMode(CORNER);
    rect(xpos, ypos, swidth, sheight);
    if(over || locked) {
      fill(153, 102, 0);
    } 
    else {
      fill(102, 102, 102);
    }
    rect(spos, ypos, sheight, sheight);
  }

  public void setPos(float s) {
    spos = xpos + s*(sposMax-sposMin);
    newspos = spos;
  }

  public float getPos() {
    // convert spos to be values between
    // 0 and the total width of the scrollbar
    return ((spos-xpos))/(sposMax-sposMin);// * ratio;
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--hide-stop", "BestaireRadioInterActifLinux" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
